#include <iostream>
using namespace std;
#include <cassert>


class fraction
{

public: 
	int a;
	int b;

	fraction(int aValue, int bValue) {
		assert(bValue!=0);
		a = aValue; 
		b = bValue;
	}; 
	fraction() {a=0;b=1;} ;

	void print() {cout<<"("<<a<<"/"<<b<<")";};

	fraction add(const fraction & y) const;
	fraction mult(const fraction & y) const;
	fraction neg() const {fraction x(-a,b);return x;};
	bool  isEqual(const fraction & y) const;
    fraction simplify() const;

};





fraction fraction::add(const fraction & y) const 
{
	fraction x;
    x.b=y.b*b;
	x.a=y.b*a+b*y.a;
	return x;
}


fraction fraction::mult(const fraction & y) const 
{
	fraction x;
    x.a=y.a*a;
	x.b=y.b*b;
	return x;
}


bool fraction::isEqual(const fraction & y) const 
{
	return (a*y.b== b*y.a);
}

fraction fraction::simplify()  const
{
	fraction x(a,b);
	if(b<0) 
	{
		x.a = -x.a;
		x.b = -x.b;
	}
	int d = x.b;
	while(d>=2) {
		if(x.b%d==0 && x.a%d==0)
			break;
		d--;
	}
    x.a = x.a/d;
	x.b=x.b/d;
	return x;
}

	
int main()
{

        fraction x(1,2), y(2,3);

		fraction z= x.add(y);
		z.print();cout<<endl;

		z = x.mult(y);
		z.print();cout<<endl;

	    z = x.neg();
		z.print();cout<<endl;

		fraction w(2,4);
       
		cout<<(x.isEqual(y))<<endl;
		cout<<(x.isEqual(w))<<endl;

		
		fraction u(120,180);
		fraction v;
		v = y.simplify();
		v.print();

		cout<<endl;cout<<endl;


		return 0;

}